Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs	(revision 15242)
@@ -47,14 +47,15 @@
       this.components = new System.ComponentModel.Container();
       this.splitContainer = new System.Windows.Forms.SplitContainer();
-      this.checkedItemList = new HeuristicLab.DataPreprocessing.Views.PreprocessingCheckedItemListView();
-      this.variablesListcontextMenuStrip = new System.Windows.Forms.ContextMenuStrip(this.components);
-      this.checkInputsTargetToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.checkOnlyInputsTargetToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.checkAllToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.uncheckAllToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.variablesGroupBox = new System.Windows.Forms.GroupBox();
+      this.variablesListView = new System.Windows.Forms.ListView();
+      this.columnHeader = ((System.Windows.Forms.ColumnHeader)(new System.Windows.Forms.ColumnHeader()));
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.uncheckAllButton = new System.Windows.Forms.Button();
+      this.checkAllButton = new System.Windows.Forms.Button();
+      this.checkInputsTargetButton = new System.Windows.Forms.Button();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
       this.splitContainer.SuspendLayout();
-      this.variablesListcontextMenuStrip.SuspendLayout();
+      this.variablesGroupBox.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -62,4 +63,5 @@
       // 
       this.splitContainer.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.splitContainer.FixedPanel = System.Windows.Forms.FixedPanel.Panel1;
       this.splitContainer.Location = new System.Drawing.Point(0, 0);
       this.splitContainer.Name = "splitContainer";
@@ -67,61 +69,77 @@
       // splitContainer.Panel1
       // 
-      this.splitContainer.Panel1.Controls.Add(this.checkedItemList);
-      this.splitContainer.Size = new System.Drawing.Size(654, 403);
-      this.splitContainer.SplitterDistance = 91;
+      this.splitContainer.Panel1.Controls.Add(this.variablesGroupBox);
+      this.splitContainer.Size = new System.Drawing.Size(940, 698);
+      this.splitContainer.SplitterDistance = 180;
       this.splitContainer.TabIndex = 7;
       // 
-      // checkedItemList
+      // variablesGroupBox
       // 
-      this.checkedItemList.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.variablesGroupBox.Controls.Add(this.uncheckAllButton);
+      this.variablesGroupBox.Controls.Add(this.checkAllButton);
+      this.variablesGroupBox.Controls.Add(this.checkInputsTargetButton);
+      this.variablesGroupBox.Controls.Add(this.variablesListView);
+      this.variablesGroupBox.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.variablesGroupBox.Location = new System.Drawing.Point(0, 0);
+      this.variablesGroupBox.Name = "variablesGroupBox";
+      this.variablesGroupBox.Size = new System.Drawing.Size(180, 698);
+      this.variablesGroupBox.TabIndex = 7;
+      this.variablesGroupBox.TabStop = false;
+      this.variablesGroupBox.Text = "Variables";
+      // 
+      // variablesListView
+      // 
+      this.variablesListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.checkedItemList.Caption = "View";
-      this.checkedItemList.Content = null;
-      this.checkedItemList.ContextMenuStrip = this.variablesListcontextMenuStrip;
-      this.checkedItemList.Location = new System.Drawing.Point(4, 4);
-      this.checkedItemList.Name = "checkedItemList";
-      this.checkedItemList.ReadOnly = false;
-      this.checkedItemList.Size = new System.Drawing.Size(84, 252);
-      this.checkedItemList.TabIndex = 4;
+      this.variablesListView.CheckBoxes = true;
+      this.variablesListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
+            this.columnHeader});
+      this.variablesListView.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.None;
+      this.variablesListView.HideSelection = false;
+      this.variablesListView.Location = new System.Drawing.Point(6, 49);
+      this.variablesListView.Name = "variablesListView";
+      this.variablesListView.Size = new System.Drawing.Size(168, 643);
+      this.variablesListView.TabIndex = 12;
+      this.variablesListView.UseCompatibleStateImageBehavior = false;
+      this.variablesListView.View = System.Windows.Forms.View.Details;
       // 
-      // variablesListcontextMenuStrip
+      // columnHeader
       // 
-      this.variablesListcontextMenuStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
-            this.checkInputsTargetToolStripMenuItem,
-            this.checkOnlyInputsTargetToolStripMenuItem,
-            this.checkAllToolStripMenuItem,
-            this.uncheckAllToolStripMenuItem});
-      this.variablesListcontextMenuStrip.Name = "variablesListcontextMenuStrip";
-      this.variablesListcontextMenuStrip.Size = new System.Drawing.Size(211, 92);
-      this.variablesListcontextMenuStrip.Opening += new System.ComponentModel.CancelEventHandler(this.variablesListcontextMenuStrip_Opening);
+      this.columnHeader.Text = "";
+      this.columnHeader.Width = 164;
       // 
-      // checkInputsTargetToolStripMenuItem
+      // uncheckAllButton
       // 
-      this.checkInputsTargetToolStripMenuItem.Name = "checkInputsTargetToolStripMenuItem";
-      this.checkInputsTargetToolStripMenuItem.Size = new System.Drawing.Size(210, 22);
-      this.checkInputsTargetToolStripMenuItem.Text = "Check Inputs+Target";
-      this.checkInputsTargetToolStripMenuItem.Click += new System.EventHandler(this.checkInputsTargetToolStripMenuItem_Click);
+      this.uncheckAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.None;
+      this.uncheckAllButton.Location = new System.Drawing.Point(66, 19);
+      this.uncheckAllButton.Name = "uncheckAllButton";
+      this.uncheckAllButton.Size = new System.Drawing.Size(24, 24);
+      this.uncheckAllButton.TabIndex = 9;
+      this.toolTip.SetToolTip(this.uncheckAllButton, "Show None");
+      this.uncheckAllButton.UseVisualStyleBackColor = true;
+      this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
       // 
-      // checkOnlyInputsTargetToolStripMenuItem
+      // checkAllButton
       // 
-      this.checkOnlyInputsTargetToolStripMenuItem.Name = "checkOnlyInputsTargetToolStripMenuItem";
-      this.checkOnlyInputsTargetToolStripMenuItem.Size = new System.Drawing.Size(210, 22);
-      this.checkOnlyInputsTargetToolStripMenuItem.Text = "Check only Inputs+Target";
-      this.checkOnlyInputsTargetToolStripMenuItem.Click += new System.EventHandler(this.checkOnlyInputsTargetToolStripMenuItem_Click);
+      this.checkAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.All;
+      this.checkAllButton.Location = new System.Drawing.Point(6, 19);
+      this.checkAllButton.Name = "checkAllButton";
+      this.checkAllButton.Size = new System.Drawing.Size(24, 24);
+      this.checkAllButton.TabIndex = 7;
+      this.toolTip.SetToolTip(this.checkAllButton, "Show All");
+      this.checkAllButton.UseVisualStyleBackColor = true;
+      this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
       // 
-      // checkAllToolStripMenuItem
+      // checkInputsTargetButton
       // 
-      this.checkAllToolStripMenuItem.Name = "checkAllToolStripMenuItem";
-      this.checkAllToolStripMenuItem.Size = new System.Drawing.Size(210, 22);
-      this.checkAllToolStripMenuItem.Text = "Check All";
-      this.checkAllToolStripMenuItem.Click += new System.EventHandler(this.checkAllToolStripMenuItem_Click);
-      // 
-      // uncheckAllToolStripMenuItem
-      // 
-      this.uncheckAllToolStripMenuItem.Name = "uncheckAllToolStripMenuItem";
-      this.uncheckAllToolStripMenuItem.Size = new System.Drawing.Size(210, 22);
-      this.uncheckAllToolStripMenuItem.Text = "Uncheck All";
-      this.uncheckAllToolStripMenuItem.Click += new System.EventHandler(this.uncheckAllToolStripMenuItem_Click);
+      this.checkInputsTargetButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.Inputs;
+      this.checkInputsTargetButton.Location = new System.Drawing.Point(36, 19);
+      this.checkInputsTargetButton.Name = "checkInputsTargetButton";
+      this.checkInputsTargetButton.Size = new System.Drawing.Size(24, 24);
+      this.checkInputsTargetButton.TabIndex = 8;
+      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Show Inputs & Target");
+      this.checkInputsTargetButton.UseVisualStyleBackColor = true;
+      this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
       // 
       // PreprocessingCheckedVariablesView
@@ -131,9 +149,9 @@
       this.Controls.Add(this.splitContainer);
       this.Name = "PreprocessingCheckedVariablesView";
-      this.Size = new System.Drawing.Size(654, 403);
+      this.Size = new System.Drawing.Size(940, 698);
       this.splitContainer.Panel1.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
       this.splitContainer.ResumeLayout(false);
-      this.variablesListcontextMenuStrip.ResumeLayout(false);
+      this.variablesGroupBox.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -141,12 +159,12 @@
 
     #endregion
-
-    protected PreprocessingCheckedItemListView checkedItemList;
     protected System.Windows.Forms.SplitContainer splitContainer;
-    private System.Windows.Forms.ContextMenuStrip variablesListcontextMenuStrip;
-    private System.Windows.Forms.ToolStripMenuItem checkInputsTargetToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem checkAllToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem uncheckAllToolStripMenuItem;
-    private System.Windows.Forms.ToolStripMenuItem checkOnlyInputsTargetToolStripMenuItem;
+    private System.Windows.Forms.ToolTip toolTip;
+    private System.Windows.Forms.ColumnHeader columnHeader;
+    private System.Windows.Forms.ListView variablesListView;
+    private System.Windows.Forms.GroupBox variablesGroupBox;
+    private System.Windows.Forms.Button checkInputsTargetButton;
+    private System.Windows.Forms.Button uncheckAllButton;
+    private System.Windows.Forms.Button checkAllButton;
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.cs	(revision 15242)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
 using System.Drawing;
@@ -34,4 +33,5 @@
   [Content(typeof(PreprocessingChartContent), false)]
   public abstract partial class PreprocessingCheckedVariablesView : ItemView {
+    protected bool SuppressCheckedChangedUpdate = false;
 
     public new PreprocessingChartContent Content {
@@ -48,5 +48,5 @@
     }
     protected IList<string> GetCheckedVariables() {
-      return checkedItemList.Content.CheckedItems.Select(i => i.Value.Value).ToList();
+      return Content.VariableItemList.CheckedItems.Select(i => i.Value.Value).ToList();
     }
 
@@ -55,35 +55,38 @@
       if (Content == null) return;
 
-      if (Content.VariableItemList == null) {
-        IList<string> inputs = Content.PreprocessingData.InputVariables;
-        if (Content.PreprocessingData.TargetVariable != null)
-          inputs = inputs.Union(new[] { Content.PreprocessingData.TargetVariable }).ToList();
-        Content.VariableItemList = Content.CreateVariableItemList(inputs);
-      } else {
-        var checkedNames = Content.VariableItemList.CheckedItems.Select(x => x.Value.Value);
-        Content.VariableItemList = Content.CreateVariableItemList(checkedNames.ToList());
+      variablesListView.ItemChecked -= variablesListView_ItemChecked;
+      variablesListView.Items.Clear();
+      foreach (var variable in Content.VariableItemList) {
+        bool isInputTarget = Content.PreprocessingData.InputVariables.Contains(variable.Value)
+          || Content.PreprocessingData.TargetVariable == variable.Value;
+        variablesListView.Items.Add(new ListViewItem(variable.Value) {
+          Tag = variable,
+          Checked = IsVariableChecked(variable.Value),
+          ForeColor = isInputTarget ? Color.Black : Color.Gray
+        });
       }
-      Content.VariableItemList.CheckedItemsChanged += CheckedItemsChanged;
-
-      checkedItemList.Content = Content.VariableItemList;
-      var target = Content.PreprocessingData.TargetVariable;
-      var inputAndTarget = Content.PreprocessingData.InputVariables.Union(target != null ? new[] { target } : new string[] { });
-      foreach (var col in Content.PreprocessingData.GetDoubleVariableNames().Except(inputAndTarget)) {
-        var listViewItem = checkedItemList.ItemsListView.FindItemWithText(col, false, 0, false);
-        listViewItem.ForeColor = Color.LightGray;
-      }
+      variablesListView.ItemChecked += variablesListView_ItemChecked;
     }
     protected override void RegisterContentEvents() {
       base.RegisterContentEvents();
       Content.PreprocessingData.Changed += PreprocessingData_Changed;
-      Content.PreprocessingData.SelectionChanged += PreprocessingData_SelctionChanged;
+      Content.VariableItemList.CheckedItemsChanged += CheckedItemsChanged;
     }
+
     protected override void DeregisterContentEvents() {
       Content.PreprocessingData.Changed -= PreprocessingData_Changed;
-      Content.PreprocessingData.SelectionChanged -= PreprocessingData_SelctionChanged;
+      Content.VariableItemList.CheckedItemsChanged -= CheckedItemsChanged;
       base.DeregisterContentEvents();
     }
 
     protected virtual void CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<StringValue>> checkedItems) {
+      // sync listview
+      foreach (var item in checkedItems.Items)
+        variablesListView.Items[item.Index].Checked = Content.VariableItemList.ItemChecked(item.Value);
+    }
+    private void variablesListView_ItemChecked(object sender, ItemCheckedEventArgs e) {
+      // sync checked item list
+      var variable = (StringValue)e.Item.Tag;
+      Content.VariableItemList.SetItemCheckedState(variable, e.Item.Checked);
     }
 
@@ -109,5 +112,5 @@
       Content.VariableItemList.Add(new StringValue(name));
       if (!Content.PreprocessingData.InputVariables.Contains(name) && Content.PreprocessingData.TargetVariable != name) {
-        var listViewItem = checkedItemList.ItemsListView.FindItemWithText(name, false, 0, false);
+        var listViewItem = variablesListView.FindItemWithText(name, false, 0, false);
         listViewItem.ForeColor = Color.LightGray;
       }
@@ -118,43 +121,35 @@
         Content.VariableItemList.Remove(stringValue);
     }
-    protected virtual void UpdateVariable(string name) {
-    }
-    protected virtual void ResetAllVariables() {
+    protected virtual void UpdateVariable(string name) { }
+    protected virtual void ResetAllVariables() { }
+    protected virtual void CheckedChangedUpdate() { }
+
+    private void checkInputsTargetButton_Click(object sender, System.EventArgs e) {
+      SuppressCheckedChangedUpdate = true;
+      foreach (var name in Content.VariableItemList) {
+        var isInputTarget = Content.PreprocessingData.InputVariables.Contains(name.Value) || Content.PreprocessingData.TargetVariable == name.Value;
+        Content.VariableItemList.SetItemCheckedState(name, isInputTarget);
+      }
+      SuppressCheckedChangedUpdate = false;
+      CheckedChangedUpdate();
     }
 
-    protected virtual void PreprocessingData_SelctionChanged(object sender, EventArgs e) {
+    private void checkAllButton_Click(object sender, System.EventArgs e) {
+      SuppressCheckedChangedUpdate = true;
+      foreach (var name in Content.VariableItemList) {
+        Content.VariableItemList.SetItemCheckedState(name, true);
+      }
+      SuppressCheckedChangedUpdate = false;
+      CheckedChangedUpdate();
     }
 
-    #region ContextMenu Events
-    private void variablesListcontextMenuStrip_Opening(object sender, System.ComponentModel.CancelEventArgs e) {
-      var data = Content.PreprocessingData;
-      checkInputsTargetToolStripMenuItem.Text = "Check Inputs" + (data.TargetVariable != null ? "+Target" : "");
-      checkOnlyInputsTargetToolStripMenuItem.Text = "Check only Inputs" + (data.TargetVariable != null ? "+Target" : "");
+    private void uncheckAllButton_Click(object sender, System.EventArgs e) {
+      SuppressCheckedChangedUpdate = true;
+      foreach (var name in Content.VariableItemList) {
+        Content.VariableItemList.SetItemCheckedState(name, false);
+      }
+      SuppressCheckedChangedUpdate = false;
+      CheckedChangedUpdate();
     }
-    private void checkInputsTargetToolStripMenuItem_Click(object sender, EventArgs e) {
-      foreach (var name in checkedItemList.Content) {
-        var isInputTarget = Content.PreprocessingData.InputVariables.Contains(name.Value) || Content.PreprocessingData.TargetVariable == name.Value;
-        if (isInputTarget) {
-          checkedItemList.Content.SetItemCheckedState(name, true);
-        }
-      }
-    }
-    private void checkOnlyInputsTargetToolStripMenuItem_Click(object sender, EventArgs e) {
-      foreach (var name in checkedItemList.Content) {
-        var isInputTarget = Content.PreprocessingData.InputVariables.Contains(name.Value) || Content.PreprocessingData.TargetVariable == name.Value;
-        checkedItemList.Content.SetItemCheckedState(name, isInputTarget);
-      }
-    }
-    private void checkAllToolStripMenuItem_Click(object sender, EventArgs e) {
-      foreach (var name in checkedItemList.Content) {
-        checkedItemList.Content.SetItemCheckedState(name, true);
-      }
-    }
-    private void uncheckAllToolStripMenuItem_Click(object sender, EventArgs e) {
-      foreach (var name in checkedItemList.Content) {
-        checkedItemList.Content.SetItemCheckedState(name, false);
-      }
-    }
-    #endregion
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.Designer.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.Designer.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.Designer.cs	(revision 15242)
@@ -22,5 +22,5 @@
 #endregion
 
-namespace HeuristicLab.Problems.DataAnalysis.Views {
+namespace HeuristicLab.DataPreprocessing.Views {
   partial class PreprocessingFeatureCorrelationView {
     /// <summary> 
@@ -48,8 +48,88 @@
     private void InitializeComponent() {
       this.components = new System.ComponentModel.Container();
+      this.checkInputsTargetButton = new System.Windows.Forms.Button();
+      this.uncheckAllButton = new System.Windows.Forms.Button();
+      this.checkAllButton = new System.Windows.Forms.Button();
+      this.correlationView = new HeuristicLab.Problems.DataAnalysis.Views.FeatureCorrelationView();
+      this.variablesLabel = new System.Windows.Forms.Label();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.SuspendLayout();
+      // 
+      // checkInputsTargetButton
+      // 
+      this.checkInputsTargetButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.Inputs;
+      this.checkInputsTargetButton.Location = new System.Drawing.Point(736, 5);
+      this.checkInputsTargetButton.Name = "checkInputsTargetButton";
+      this.checkInputsTargetButton.Size = new System.Drawing.Size(24, 24);
+      this.checkInputsTargetButton.TabIndex = 14;
+      this.toolTip.SetToolTip(this.checkInputsTargetButton, "Inputs & Target Variables");
+      this.checkInputsTargetButton.UseVisualStyleBackColor = true;
+      this.checkInputsTargetButton.Click += new System.EventHandler(this.checkInputsTargetButton_Click);
+      // 
+      // uncheckAllButton
+      // 
+      this.uncheckAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.None;
+      this.uncheckAllButton.Location = new System.Drawing.Point(766, 5);
+      this.uncheckAllButton.Name = "uncheckAllButton";
+      this.uncheckAllButton.Size = new System.Drawing.Size(24, 24);
+      this.uncheckAllButton.TabIndex = 12;
+      this.toolTip.SetToolTip(this.uncheckAllButton, "None");
+      this.uncheckAllButton.UseVisualStyleBackColor = true;
+      this.uncheckAllButton.Click += new System.EventHandler(this.uncheckAllButton_Click);
+      // 
+      // checkAllButton
+      // 
+      this.checkAllButton.Image = global::HeuristicLab.DataPreprocessing.Views.PreprocessingIcons.All;
+      this.checkAllButton.Location = new System.Drawing.Point(706, 5);
+      this.checkAllButton.Name = "checkAllButton";
+      this.checkAllButton.Size = new System.Drawing.Size(24, 24);
+      this.checkAllButton.TabIndex = 13;
+      this.toolTip.SetToolTip(this.checkAllButton, "All");
+      this.checkAllButton.UseVisualStyleBackColor = true;
+      this.checkAllButton.Click += new System.EventHandler(this.checkAllButton_Click);
+      // 
+      // correlationView
+      // 
+      this.correlationView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.correlationView.Caption = "Feature Correlation View";
+      this.correlationView.Content = null;
+      this.correlationView.Location = new System.Drawing.Point(0, 0);
+      this.correlationView.Name = "correlationView";
+      this.correlationView.ReadOnly = false;
+      this.correlationView.Size = new System.Drawing.Size(1013, 640);
+      this.correlationView.TabIndex = 18;
+      // 
+      // variablesLabel
+      // 
+      this.variablesLabel.AutoSize = true;
+      this.variablesLabel.Location = new System.Drawing.Point(650, 11);
+      this.variablesLabel.Name = "variablesLabel";
+      this.variablesLabel.Size = new System.Drawing.Size(50, 13);
+      this.variablesLabel.TabIndex = 15;
+      this.variablesLabel.Text = "Variables";
+      // 
+      // PreprocessingFeatureCorrelationView
+      // 
+      this.Controls.Add(this.variablesLabel);
+      this.Controls.Add(this.checkInputsTargetButton);
+      this.Controls.Add(this.uncheckAllButton);
+      this.Controls.Add(this.checkAllButton);
+      this.Controls.Add(this.correlationView);
+      this.Name = "PreprocessingFeatureCorrelationView";
+      this.Size = new System.Drawing.Size(1013, 640);
       this.ResumeLayout(false);
+      this.PerformLayout();
+
     }
 
     #endregion
+    private System.Windows.Forms.Button checkInputsTargetButton;
+    private System.Windows.Forms.Button uncheckAllButton;
+    private System.Windows.Forms.Button checkAllButton;
+    private HeuristicLab.Problems.DataAnalysis.Views.FeatureCorrelationView correlationView;
+    private System.Windows.Forms.ToolTip toolTip;
+    private System.Windows.Forms.Label variablesLabel;
   }
 }
Index: /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.cs
===================================================================
--- /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.cs	(revision 15241)
+++ /stable/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingFeatureCorrelationView.cs	(revision 15242)
@@ -20,14 +20,14 @@
 #endregion
 
-using System.Windows.Forms;
-using HeuristicLab.DataPreprocessing;
+using System;
+using System.Linq;
+using HeuristicLab.Data.Views;
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
 
-namespace HeuristicLab.Problems.DataAnalysis.Views {
+namespace HeuristicLab.DataPreprocessing.Views {
   [View("Preprocessing Feature Correlation View")]
-  [Content(typeof(CorrelationMatrixContent), false)]
+  [Content(typeof(CorrelationMatrixContent), true)]
   public partial class PreprocessingFeatureCorrelationView : AsynchronousContentView {
-
     public new CorrelationMatrixContent Content {
       get { return (CorrelationMatrixContent)base.Content; }
@@ -35,13 +35,7 @@
     }
 
-    FeatureCorrelationView correlationView;
-
     public PreprocessingFeatureCorrelationView() {
       InitializeComponent();
-      correlationView = new FeatureCorrelationView();
-      correlationView.Dock = DockStyle.Fill;
-      this.Controls.Add(correlationView);
     }
-
 
     protected override void RegisterContentEvents() {
@@ -61,11 +55,31 @@
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      if (Content == null) {
-        correlationView.Content = null;
+      correlationView.Content = Content != null ? Content.ProblemData : null;
+    }
+
+    #region Check Variables
+    private void checkAllButton_Click(object sender, System.EventArgs e) {
+      SetVisibility(x => true);
+    }
+    private void checkInputsTargetButton_Click(object sender, System.EventArgs e) {
+      var ppd = Content.PreprocessingData;
+      SetVisibility(x => ppd.InputVariables.Contains(x) || ppd.TargetVariable == x);
+    }
+    private void uncheckAllButton_Click(object sender, System.EventArgs e) {
+      SetVisibility(x => false);
+    }
+    private void SetVisibility(Func<string, bool> check) {
+      var dataView = (EnhancedStringConvertibleMatrixView)correlationView.Controls.Find("DataView", searchAllChildren: true).Single();
+      var ppd = Content.PreprocessingData;
+      var visibilities = ppd.VariableNames.Where((v, i) => ppd.VariableHasType<double>(i)).Select(check).ToList();
+      if (dataView.Content.Rows != dataView.Content.Columns || dataView.Content.Rows != visibilities.Count)
         return;
-      }
 
-      correlationView.Content = Content.ProblemData;
+      dataView.ColumnVisibility = visibilities;
+      dataView.RowVisibility = visibilities;
+      dataView.UpdateColumnHeaders();
+      dataView.UpdateRowHeaders();
     }
+    #endregion
   }
 }
